# SdFat: Arduino/libraries/SdFat/SdBaseFile.h File Reference

SdBaseFile.h File Reference

SdBaseFile class. More...

`#include <Arduino.h>`
`#include <SdFatConfig.h>`
`#include <SdVolume.h>`
`#include <utility/FatApiConstants.h>`
Include dependency graph for SdBaseFile.h:
This graph shows which files directly or indirectly include this file:

## Classes

struct | FatPos_t
| internal type for istream do not use in user apps More...
class | SdBaseFile
| Base class for SdFile with Print and C++ streams. More...

## Macros

#define | PGM_P const char*
#define | pgm_read_byte(addr) (*(const unsigned char*)(addr))
#define | pgm_read_word(addr) (*(const uint16_t*)(addr))
#define | PROGMEM const
#define | PSTR(x) (x)

## Variables

uint8_t const | FAT_FILE_TYPE_CLOSED = 0
uint8_t const | FAT_FILE_TYPE_MIN_DIR = FAT_FILE_TYPE_ROOT_FIXED
uint8_t const | FAT_FILE_TYPE_NORMAL = 1
uint8_t const | FAT_FILE_TYPE_ROOT32 = 3
uint8_t const | FAT_FILE_TYPE_ROOT_FIXED = 2
uint8_t const | FAT_FILE_TYPE_SUBDIR = 4

## Detailed Description

SdBaseFile class.

## Macro Definition Documentation

#define PGM_P const char*

pointer to flash for ARM

#define pgm_read_byte | ( |  | addr | ) | (*(const unsigned char*)(addr))

read 8-bits from flash for ARM

#define pgm_read_word | ( |  | addr | ) | (*(const uint16_t*)(addr))

read 16-bits from flash for ARM

#define PROGMEM const

store in flash for ARM

#define PSTR | ( |  | x | ) | (x)

store literal string in flash for ARM

## Variable Documentation

uint8_t const FAT_FILE_TYPE_CLOSED = 0

This file has not been opened.

uint8_t const FAT_FILE_TYPE_MIN_DIR = FAT_FILE_TYPE_ROOT_FIXED

Test value for directory type

uint8_t const FAT_FILE_TYPE_NORMAL = 1

A normal file

uint8_t const FAT_FILE_TYPE_ROOT32 = 3

A FAT32 root directory

uint8_t const FAT_FILE_TYPE_ROOT_FIXED = 2

A FAT12 or FAT16 root directory

uint8_t const FAT_FILE_TYPE_SUBDIR = 4

A subdirectory file